/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.stresstestingreporttemplates;

import cdac.medinfo.sdk.dcm30_04.baselibs.ContentSequenceItem;
import cdac.medinfo.sdk.dcm30_04.enums.EnumContinuityOfContent;
import cdac.medinfo.sdk.dcm30_04.srtree.SRTree;
import cdac.medinfo.sdk.dcm30_04.templates.cid.CardiacProceduralStateValues_CID3101;
import cdac.medinfo.sdk.dcm30_04.templates.cid.StressTestProcedurePhases_CID3207;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CardiacProceduralStateValues;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_StressTestPhaseData;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_StressTestProcedurePhases;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_StressTestPhaseData;
import cdac.medinfo.sdk.dcm30_04.templates.generaltemplates.Template;

/**
 * This class represents StressTestPhaseData_TID3303
 */
public class StressTestPhaseData_TID3303  extends Template
{
	private static final String strCM = null;
	
	/**
	 * Object of CardiacProceduralStateValues_CID3101
	 */
	private CardiacProceduralStateValues_CID3101 objCardiacProceduralStateValuesCID3101;
	
	/**
	 * Object of StressTestProcedurePhases_CID3207
	 */
	private StressTestProcedurePhases_CID3207 objStressTestProcedurePhasesCID3207;
	
	/**
	 * Object of StressTestProcedureDescription_TID3301
	 */
	private StressTestProcedureDescription_TID3301 objStressTestProcedureDescriptionTID3301;
	
	/**
	 * Object of StressTestMeasurementGroup_TID3304
	 */
	private StressTestMeasurementGroup_TID3304 objStressTestMeasurementGroupTID3304;
	
	/**
	 * Object of NMPETPerfusionMeasurementGroup_TID3307
	 */
	private NMPETPerfusionMeasurementGroup_TID3307 objNMPETPerfusionMeasurementGroupTID3307;
	
	/**
	 * Object of StressEchoMeasurementGroup_TID3309
	 */
	private StressEchoMeasurementGroup_TID3309 objStressEchoMeasurementGroupTID3309;
	
	/**
	 * Instantiates a new StressTestPhaseData_TID3303 Template.
	 * @param objTree Object of SRTree.
	 */
	public StressTestPhaseData_TID3303(SRTree objTree)
	{
		super(objTree);
	}

	/**
	 * Retrieves Stress Test Measurement Group.
	 * @return objStressTestMeasurementGroupTID3304 Object of StressTestMeasurementGroup_TID3304 
	 */
	public StressTestMeasurementGroup_TID3304 getStressTestMeasurementGroup()
	{
		if(null == this.objStressTestMeasurementGroupTID3304)
			this.objStressTestMeasurementGroupTID3304 = new StressTestMeasurementGroup_TID3304(getSRTree());
		return this.objStressTestMeasurementGroupTID3304;
	}
	
	/**
	 * Retrieves NMPET Perfusion Measurement Group.
	 * @return objNMPETPerfusionMeasurementGroupTID3307 Object of NMPETPerfusionMeasurementGroup_TID3307 
	 */
	public NMPETPerfusionMeasurementGroup_TID3307 getNMPETPerfusionMeasurementGroup()
	{
		if(null == this.objNMPETPerfusionMeasurementGroupTID3307)
			this.objNMPETPerfusionMeasurementGroupTID3307 = new NMPETPerfusionMeasurementGroup_TID3307(getSRTree());
		return this.objNMPETPerfusionMeasurementGroupTID3307;
	}
	
	/**
	 * Retrieves Stress Echo Measurement Group.
	 * @return objStressEchoMeasurementGroupTID3309 Object of StressEchoMeasurementGroup_TID3309 
	 */
	public StressEchoMeasurementGroup_TID3309 getStressEchoMeasurementGroup()
	{
		if(null == this.objStressEchoMeasurementGroupTID3309)
			this.objStressEchoMeasurementGroupTID3309 = new StressEchoMeasurementGroup_TID3309(getSRTree());
		return this.objStressEchoMeasurementGroupTID3309;
	}
		
	/**
	 * Retrieves Stress Test Procedure Description.
	 * @return objStressTestProcedureDescriptionTID3301 Object of StressTestProcedureDescription_TID3301 
	 */
	public StressTestProcedureDescription_TID3301 getStressTestProcedureDescription()
	{
		if(null == this.objStressTestProcedureDescriptionTID3301)
			this.objStressTestProcedureDescriptionTID3301 = new StressTestProcedureDescription_TID3301(getSRTree());
		return this.objStressTestProcedureDescriptionTID3301;
	}
	
	/**
	 * Sets the value for Procedure phase.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setProcedurephase(int[] arrPosition)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressTestPhaseData.PROCEDURE_PHASE.getValue();
		String strCodeValue = EnumCV_StressTestPhaseData.PROCEDURE_PHASE_G_7292.getValue();
		String strCSD = EnumCodingSchemeDesignator.SRT.getValue();

		/**
		 *Creating a node of Value Type TEXT and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createTextNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, "");
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for Protocol Stage.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param arrNumericValue 
	 */
	public void setProtocolStage(int[] arrPosition, String[] arrNumericValue)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressTestPhaseData.PROTOCOL_STAGE.getValue();
		String strCodeValue = EnumCV_StressTestPhaseData.PROTOCOL_STAGE_109055.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 *Creating a node of Value Type NUM and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createNumNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, arrNumericValue, "", "", "", "", "", "", "", "");
		getSRTree().addChild(objContentSequenceItem);
	}
	
	/**
	 * Sets the value for Findings.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumContinuityOfContent 
	 */
	public void setFindings(int[] arrPosition, EnumContinuityOfContent enumContinuityOfContent)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressTestPhaseData.FINDINGS.getValue();
		String strCodeValue = EnumCV_StressTestPhaseData.FINDINGS_121070.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.DCM.getValue();
	
		/**
		 *Creating a node of Value Type CONTAINER and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createContainer(arrPosition, strCodeMeaning, strCodeValue, strCSDesg, enumContinuityOfContent);
		getSRTree().addChild(objContentSequenceItem);
	}
	
	/**
	 * Sets the value for Procedure phase.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setProcedurephase(int[] arrPosition, EnumCM_StressTestProcedurePhases enumStressTestProcedurePhases)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressTestPhaseData.PROCEDURE_PHASE.getValue();
		String strCodeValue = EnumCV_StressTestPhaseData.PROCEDURE_PHASE_G_7292.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		
		if(null== this.objStressTestProcedurePhasesCID3207)
			this.objStressTestProcedurePhasesCID3207 = new StressTestProcedurePhases_CID3207();
		this.objStressTestProcedurePhasesCID3207.setStressTestProcedurePhases(enumStressTestProcedurePhases);

		String strCM = objStressTestProcedurePhasesCID3207.getCodeMeaning();
		String strCV = objStressTestProcedurePhasesCID3207.getCodeValue();
		String strCSD = objStressTestProcedurePhasesCID3207.getCodingSchemeDesignator();
		String strSNOMEDCTID = objStressTestProcedurePhasesCID3207.getSNOMEDCTID();
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strCSDesg, strCV, strCM,strSNOMEDCTID);
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for Procedure phase.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setProcedurephase(int[] arrPosition, EnumCM_CardiacProceduralStateValues enumCardiacProceduralStateValues)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressTestPhaseData.PROCEDURE_PHASE.getValue();
		String strCodeValue = EnumCV_StressTestPhaseData.PROCEDURE_PHASE_G_7292.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		
		if(null== this.objCardiacProceduralStateValuesCID3101)
			this.objCardiacProceduralStateValuesCID3101 = new CardiacProceduralStateValues_CID3101();
		this.objCardiacProceduralStateValuesCID3101.setCardiacProceduralStateValues(enumCardiacProceduralStateValues);

		String strCM = objCardiacProceduralStateValuesCID3101.getCodeMeaning();
		String strCV = objCardiacProceduralStateValuesCID3101.getCodeValue();
		String strCSD = objCardiacProceduralStateValuesCID3101.getCodingSchemeDesignator();
		String strSNOMEDCTID = objCardiacProceduralStateValuesCID3101.getSNOMEDCTID();
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strCSDesg, strCV, strCM,strSNOMEDCTID);
		getSRTree().addChild(objContentSequenceItem);
	}

}